//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

class TArticle : public TObject {
  private:
    String FName;
    float FPrice;
    int FStock;
  public:
    __property String Name = { read = FName, write = FName };
    __property float Price = { read = FPrice, write = FPrice };
    __property int Stock = { read = FStock, write = FStock };
};

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Articles = new TStringList;
  Articles->CaseSensitive = false;
  Articles->Sorted = true;
  // the stringlist's objects must be automatically freed upon...
  // ...destroying the stringlist
  Articles->OwnsObjects = true;

  Panel1->Visible = false;
  stStatus->Caption = "";
  edFind->Text = "";
  Grid->ColWidths[0] = 60;
  Grid->ColWidths[1] = 120;
  Grid->ColWidths[2] = 80;
  Grid->ColWidths[3] = 60;
  Grid->Cells[0][0] = "ID";
  Grid->Cells[1][0] = "Name";
  Grid->Cells[2][0] = "Price";
  Grid->Cells[3][0] = "Stock";
}
//----------------------------------------------------------------------------
void __fastcall TForm1::btnAddClick(TObject *Sender)
{
  stStatus->Caption = " Adding Article ";
  edID->Text = "";
  edName->Text = "";
  edPrice->Text = "";
  edStock->Text = "";
  Panel1->Visible = true;
  edID->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnOKClick(TObject *Sender)
{
  int index;
  String ID;
  ID = edID->Text;
  TArticle *Art = new TArticle;
  if (Articles->Find(ID, index))
    stStatus->Caption = " " + ID + " already exists";
  else {
    Art->Name = edName->Text;
    Art->Price = StrToFloat(edPrice->Text);
    Art->Stock = StrToInt(edStock->Text);
    Articles->AddObject(ID, Art);
    stStatus->Caption = " Article was added ";
    Panel1->Visible = false;
    UpdateGrid();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnCancelClick(TObject *Sender)
{
  stStatus->Caption = " No article was added ";
  Panel1->Visible = false;
}
//---------------------------------------------------------------------------
void TForm1::UpdateGrid()
{
  int index;
  Grid->RowCount = Articles->Count + 1;
  for (index = 0; index < Articles->Count; index++)
  {
    TArticle *Art = static_cast<TArticle*>(Articles->Objects[index]);
    Grid->Cells[0][index + 1] = Articles->Strings[index];
    Grid->Cells[1][index + 1] = Art->Name;
    Grid->Cells[2][index + 1] = FormatFloat("0.00", Art->Price);
    Grid->Cells[3][index + 1] = IntToStr(Art->Stock);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::btnFindIDClick(TObject *Sender)
{
  int index;
  if (Articles->Find(edFind->Text, index)) {
    stStatus->Caption = " Article was found ";
    Grid->Row = index + 1;
    Grid->SetFocus();
  }
  else
    stStatus->Caption = " Article " + edFind->Text + " not found ";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  delete Articles;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::btnFindNameClick(TObject *Sender)
{
  int index, posit;
  int foundwhere = -1;
  String S = edFind->Text;
  S = S.UpperCase(); // Find case-insensitive
  for (index = 0; index < Articles->Count; index++)
  {
    TArticle *Art = static_cast<TArticle*>(Articles->Objects[index]);
    Name = Art->Name;
    Name = Name.UpperCase(); // Find case-insensitive
    posit = Name.Pos(S);
    if (posit > 0) {
      foundwhere = index;
      break;  // if found, break out of the loop
    }
  }
  if (foundwhere > -1) {
    stStatus->Caption = " Article was found ";
    Grid->Row = foundwhere + 1;
    Grid->SetFocus();
  }
  else
    stStatus->Caption = " Article " + edFind->Text + " not found ";
}
//---------------------------------------------------------------------------

